/*
 * ArcVis - demo for the UT-Vienna Visualisierung 2 VU course
 * (http://www.cg.tuwien.ac.at/courses/Visualisierung2/)
 * Copyright (C) 2015 Adam Celarek (www.celarek.at)
 * Copyright (C) 2015 Daniel Steinboeck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ESSENTIALMATCHINGPAIRS_H
#define ESSENTIALMATCHINGPAIRS_H
#include <QStringList>
#include "Node.h"
#include "NodeList.h"
#include "RepetitionRegionList.h"
#include "RepetitionRegionInterval.h"

/**
 * @brief The EssentialMatchingPairs class locates and returns every essential matching pair
 */
class EssentialMatchingPairs
{
private:
    int pos;
    int minSubsequenceLength;
    QStringList text;
    Node rootNode;
    Node node;
    NodeList* nodeList;
    RepetitionRegionList* repRegList;

    bool isEssential(Node node, int s1, int s2, int length);

public:
    EssentialMatchingPairs(QStringList text, int minSubsequenceLength);
    bool getMatchingPair(RepetitionRegionInterval& mp1, RepetitionRegionInterval& mp2);
};

#endif // ESSENTIALMATCHINGPAIRS_H
