/*
 * ArcVis - demo for the UT-Vienna Visualisierung 2 VU course
 * (http://www.cg.tuwien.ac.at/courses/Visualisierung2/)
 * Copyright (C) 2015 Adam Celarek (www.celarek.at)
 * Copyright (C) 2015 Daniel Steinboeck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef NODE_H
#define NODE_H
#include <QString>
#include <QStringList>
#include <QList>
#include <QMap>

/**
 * @brief The Node represents a node in a tree
 */
class Node {
private:
    bool null;
    int level;
    QList<Node> children;
    QStringList text;
    QList<int> startPos;
    QMap<QString, Node>* childMap;
    QString character;

    void addChildren();

public:
    Node();
    Node(QStringList text, QString character);
    Node constructTree(QStringList text);
    void addChild(Node &child);
    Node getChild(int i);
    Node getChildWithChar(QString character);
    QList<Node> getChildren();
    void setLevel(int lvl);
    int getLevel();
    void setNull(bool b);
    bool isNull();
    void addStartPos(int pos);
    void addStartPosToChild(QString nextSymbol, int pos);
    int getStartPos(int start);
    QList<int> getStartPosList();  
    bool startsAt(int start);
    QString getCharAt(int i);
};

#endif // NODE_H
