/*
 * ArcVis - demo for the UT-Vienna Visualisierung 2 VU course
 * (http://www.cg.tuwien.ac.at/courses/Visualisierung2/)
 * Copyright (C) 2015 Adam Celarek (www.celarek.at)
 * Copyright (C) 2015 Daniel Steinboeck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "NodeList.h"

/**
 * @brief NodeList::NodeList Constructor
 * @param rootNode the root node of the tree
 */
NodeList::NodeList(Node rootNode){
    list.push(rootNode);
}

/**
 * @brief NodeList::hasNextNode check if there are nodes left in the list
 * @return returns true if there are nodes left in the list, returns false if not
 */
bool NodeList::hasNextNode(){
    if(list.empty() && nextLevelList.empty()){
        return false;
    }
    else{
        return true;
    }
}

/**
 * @brief NodeList::nextNode returns next node in list
 * @return next node in list
 */
Node NodeList::nextNode(){
    if(list.empty()){
        if(nextLevelList.isEmpty()){
            return Node();
        }
        list = nextLevelList;
        nextLevelList.clear();
    }

    Node node = list.pop();

    for(int i=0;i<node.getChildren().length();i++){
        nextLevelList.push(node.getChild(i));
    }

    return node;
}
