/*
 * ArcVis - demo for the UT-Vienna Visualisierung 2 VU course
 * (http://www.cg.tuwien.ac.at/courses/Visualisierung2/)
 * Copyright (C) 2015 Adam Celarek (www.celarek.at)
 * Copyright (C) 2015 Daniel Steinboeck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef REPETITIONREGIONINTERVALL_H
#define REPETITIONREGIONINTERVALL_H
#include <QStringList>

/**
 * @brief The RepetitionRegionInterval represents an interval of a string where a repetition occurs
 */
class RepetitionRegionInterval{
private:
    int start;
    int end;
    int substringLength;
    QStringList text;

public:
    RepetitionRegionInterval(int start, int end);
    RepetitionRegionInterval(QStringList text, int start, int end, int substringLength);
    int getStart();
    int getEnd();
    int getIntervalLength();
    int getSubstringLength();
    void setInterval(int start, int end);
    bool isFundamentalSubstring(RepetitionRegionInterval interval);
    bool haveSameFundamentalSubstring(RepetitionRegionInterval i1, RepetitionRegionInterval i2);
    bool containsInterval(RepetitionRegionInterval interval);
    bool intersectsInterval(RepetitionRegionInterval interval);
};

#endif // REPETITIONREGIONINTERVALL_H
